/*
   Licensed Materials - Property of IBM
   5724-M22, 5724-M23, 5724-M24, 5724-L01, 5724-R31
   Copyright IBM Corporation 2012, 2016. All Rights Reserved.
   US Government Users Restricted Rights- Use, duplication or disclosure
   restricted by GSA ADP Schedule Contract with IBM Corp.
*/
dojo.provide("com.ibm.bspace.spaceManager.widget.SpacesList");
dojo.declare("com.ibm.bspace.spaceManager.widget.SpacesList", [com.ibm.mm.builder.iwidget.spacemanager.widget.SpacesList], {
	_loadSpaces : function(spaceIter) {
		var hasSpaces = false;		
		spaceIter.setCursorPosition(0);
		
		// memory leak : also remove the spaceItem
		for(var i=0; i<this._spaceItems.length; i++) {
			var _si = this._spaceItems[i];
			_si.destroy();
		}
		this._spaceItems.length = 0;
		
		var containerNode = this.domNode;
		containerNode.innerHTML = "";
		
		var mpHandler = com.ibm.mashups.enabler.io.XHRMultipartFactory.create();
		mpHandler.startTransaction();
		
		while (spaceIter.hasNext()) {
			hasSpaces = true;
			var space = spaceIter.next();
			if (!this._isHiddenSpace(space) || this._canEditSpace(space)) {
				var isProcessPortalSpace = com.ibm.bspace.common.util.widget.BSpaceUtil.isProcessPortalSpace(space);
				if (!isProcessPortalSpace) {
					var node = dojo.create("div", {}, containerNode);
					
					var spaceItem = new com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceItem({
						spaceMeta: {
							title: this.enablerUtil.getNodeTitle(space) || this._bundle.I_SPACE_MANAGER_NO_TITLE,
							description: com.ibm.bspace.common.util.widget.BSpaceUtil.htmlEscape(this.enablerUtil.getNodeDescription(space)) || this._bundle.I_SPACE_MANAGER_NO_DESCRIPTION,
							iconUrl: com.ibm.bspace.common.util.widget.BSpaceUtil.getSpaceIconURL(space),
							owner: null, // will be loaded asynchronously by the space item later
							pagesNum: this._bundle.I_SPACE_MANAGER_PAGES_NUM_COUNTING,
							space: space
						}
					}, node);
					this._spaceItems.push(spaceItem);
					
					if (this._isHiddenSpace(space)) {
						dojo.addClass(spaceItem.domNode, "hidden_space");
						var len = 150;
						if (this.spaceUtil.isHomeSpace(space.getID())){
							len = 100;
						}
						var truncateNode=dojo.query("._titleDiv span[class='title']",spaceItem.domNode)[0];
						spaceItem.truncateNodeText(truncateNode ,len, "title", {fontSize:"14px"});
					}
					
					//if there is filter keyword
					var filterDijit = dijit.findWidgets(dojo.query(".filter_spaces")[0])[0];
					if (filterDijit._userEntered && filterDijit.filterBox.value) {
						dojo.publish(this._constants.Topic.Space.filter, [filterDijit.filterBox.value]);
					}
				}
			}
		}
		
		mpHandler.endTransactionDeferred().start();
		
		if (!hasSpaces) {
			containerNode.innerHTML = this._bundle.I_SPACE_MANAGER_NO_SPACES_FOUND;
		}
	},
	
	createSpace : function(space){
		if(this.domNode.childNodes.length == 1){
				if(this.domNode.childNodes[0].nodeType == 3){
					this.domNode.innerHTML = "";
				}
			}
		
		var _self = this;
		var bindNode = dojo.create("div",{}, this.domNode);
		var spaceItem = new com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceItem({
			spaceMeta: {
				title: _self.enablerUtil.getNodeTitle(space) || _self._bundle.I_SPACE_MANAGER_NO_TITLE,
				description: com.ibm.bspace.common.util.widget.BSpaceUtil.htmlEscape(_self.enablerUtil.getNodeDescription(space)) || _self._bundle.I_SPACE_MANAGER_NO_DESCRIPTION,
				iconUrl: com.ibm.bspace.common.util.widget.BSpaceUtil.getSpaceIconURL(space),
				owner: _self.spaceManagerUtil.model.getSpaceOwner(space),
				pagesNum: _self._bundle.I_SPACE_MANAGER_PAGES_NUM_COUNTING,
				space: space
			}
		}, bindNode);			
		this._spaceItems.push(spaceItem);
		
		if (space.isHidden()) {
			dojo.addClass(spaceItem.domNode, "hidden_space");
		} 			
		var truncateNode=dojo.query("._titleDiv span[class='title']",spaceItem.domNode)[0];
		spaceItem.truncateNodeText(truncateNode ,350, "title", {fontSize:"14px"});

		//if there is filter keyword
		var filterDijit = dijit.findWidgets(dojo.query(".filter_spaces")[0])[0];
		if (filterDijit._userEntered && filterDijit._inputNode.value) {
			dojo.publish(this._constants.Topic.Space.filter, [filterDijit._inputNode.value]);
		}
		
		if (dojo.style(spaceItem.domNode, "display") != "none") {
			dijit.scrollIntoView(dojo.byId("spaces_list_bottom"));
		}
	}	
});